/****************************************************************/
/*                                                      2/23/87 */
/*              RASTER SPRITE EDITOR / GRAPHICS SHELL           */
/*                                                              */
/*                           Part 2                             */
/*                                                        -PDB  */
/****************************************************************/

#include "raster.h"
#include <fcntl.h>
#include <gemdefs.h>
#include <obdefs.h>
#include <osbind.h>
#include <stdio.h>
#include <string.h>
#define or ||
#define OK 1
#define NO 2
#define LEFT 1
#define RIGHT 2
#define TOP_MENU 1
#define DEMO_MENU 0
#define LOAD 1
#define SAVE 2
#define TRUE 1
#define FALSE 0
#define CANCEL 0
#define LOW 0
#define MEDIUM 1
#define HIGH 2
#define MORE 2
#define RING_BELL() Bconout(2,7)
#define HELP 0x620000L
#define UNDO 0x610000L

		extern int	handle,wind_id,*palette,sprite_palette[16],
					message[8],I,J,K,key,button,x,y,n,response,p[8],
					but,alter_flag = 0,done_touching_up,t_response,
					box[4],draw_mode,r_w,r_h,rez,fill_index,
					touch_up_color,mask_exists;

		extern long menu2_address,menu3_address,menu_address,
					SPRITE,MASK,SHOWN,HIDDEN,BUFFER,buffer;

		extern char default_drive,filename[40],*done;


do_touch_up()
	{
	long temp;
	static char text_touch[] =
  "[0][ |   Do touch up with    |   which image,the Sprite, |\
   Mask, or Picture ?    |< Hit HELP key for help >   ][ S | M | P ]";
	v_hide_c(handle);
	for(I=2;I<7;I++)                 /*** De-highlite   ***/
	menu_tnormal(menu2_address,I,1); /*** the Menu Bar. ***/
	menu_bar(menu2_address,FALSE);
	Setscreen(HIDDEN,SHOWN,-1);
	show_picture(BUFFER);
	v_show_c(handle,0);
	t_response=form_alert(0,text_touch);
	switch(t_response)
		{
		case 1:     /* Touch up Sprite  */
			alter_flag = 1;
			buffer = SPRITE;
			temp = (long)palette;
			palette = &sprite_palette[0];
			Setpallete(palette);
			break;
		case 2:     /* Touch up Mask    */
			alter_flag = 2;
			buffer = MASK;
			break;
		case 3:     /* Touch up Picture */
			alter_flag = 3;
			buffer = BUFFER;
			break;
		}
	copy_picture(buffer,HIDDEN);     /*** Store old version     ***/
	Setscreen(buffer,buffer,-1);     /*** Do work on original   ***/
	vsf_color(handle,touch_up_color);/*** Set Fill color        ***/
	vsl_color(handle,touch_up_color);/*** Set Finger color      ***/
	vsf_interior(handle,2);          /*** Set fill to Pattern   ***/
	vsf_style(handle,fill_index);    /*** with current default. ***/
	graf_mouse(POINT_HAND,0);
	done_touching_up = FALSE;
	while ( button != 3 && done_touching_up != TRUE )
		{
		if (Cconis!=0)check_if_help_was_pressed();
		graf_mkstate(&p[0],&p[1],&button,&key);
		if (button == 1 && draw_mode == SPILL )
			{ 
			v_hide_c(handle);
			v_contourfill(handle,p[0],p[1],-1);       /*** Fill ***/
			v_show_c(handle,0);
			while ( button == 1 )
			graf_mkstate(&p[0],&p[1],&button,&key);
			}
		else if ( button == 1 && draw_mode != SPILL )
			{
			while ( button == 1 )
			{
			graf_mkstate(&p[2],&p[3],&button,&key);
			v_hide_c(handle);
			v_pline(handle,2,p);                      /*** Draw ***/
			v_show_c(handle,0);
			p[0]=p[2];
			p[1]=p[3];
			}
			}
		if ( button == 2 ) deal_with_users_request();
		}
	v_hide_c(handle);
	copy_picture(BUFFER,SHOWN);
	if ( t_response == 1 ) palette = (int*)temp;
	Setpallete(palette);
	if ( t_response != 3 ) define_field();
	Setscreen(SHOWN,SHOWN,-1);
	menu_bar(menu2_address,TRUE);
	menu_ienable(menu2_address,RESTORE,TRUE);
	graf_mouse(ARROW,0);
	v_show_c(handle,0);
	}



deal_with_users_request()
	{
	int *d;
	graf_mouse(ARROW,0);
	while ( button == 2 ) graf_mkstate(d,d,&button,d);
	Setscreen(SHOWN,SHOWN,-1);
	set_window();
	while ( button != 2 )
	{
	v_hide_c(handle);
	update_screen(buffer,menu3_address);
	shadow_text(100,150,"This is the color",touch_up_color);
	v_rfbox(handle,box);
	v_show_c(handle,0);
	evnt_multi(MU_MESAG | MU_BUTTON,1,3,2,
	0,0,0,0,0,0,0,0,0,0,message,0,0,d,d,&button,d,d,d);
	reset_palette();
	if (message[0]==10)
		{
		switch(message[4])
			{
			case SPILL:
				draw_mode = SPILL;
				setup_fill();
				set_check(SPILL,FAT,THIN);
				button = 2;
				break;
			case FAT:
				draw_mode = FAT;
				(Getrez()==0)? I=3 : I=5;
				vsl_width(handle,I);
				set_check(FAT,SPILL,THIN);
				button = 2;
				break;
			case THIN:
				draw_mode = THIN;
				vsl_width(handle,1);
				set_check(THIN,SPILL,FAT);
				button = 2;
				break;
			case TOUCH_0:
				touch_up_color = 0;
				break;
			case TOUCH_1:
				touch_up_color = 1;
				break;
			case TOUCH_2:
				touch_up_color = 2;
				break;
			case TOUCH_3:
				touch_up_color = 3;
				break;
			case TOUCH_4:
				touch_up_color = 4;
				break;
			case TOUCH_5:
				touch_up_color = 5;
				break;
			case TOUCH_6:
				touch_up_color = 6;
				break;
			case TOUCH_7:
				touch_up_color = 7;
				break;
			case TOUCH_8:
				touch_up_color = 8;
				break;
			case TOUCH_9:
				touch_up_color = 9;
				break;
			case TOUCH_10:
				touch_up_color = 10;
				break;
			case TOUCH_11:
				touch_up_color = 11;
				break;
			case TOUCH_12:
				touch_up_color = 12;
				break;
			case TOUCH_13:
				touch_up_color = 13;
				break;
			case TOUCH_14:
				touch_up_color = 14;
				break;
			case TOUCH_15:
				touch_up_color = 15;
				break;
			case EXTRA_F:
				call_user_function();
				break;
			case ERASE:
				clear_screen_buffer(buffer);
				break;
			case DONE:
				done_touching_up = TRUE;
				button = 2;
				break;
			case ART:
				button = 2;
				break;
			}
	vsl_color(handle,touch_up_color);
	vsf_color(handle,touch_up_color);
	menu_tnormal(menu3_address,message[3],1);
	message[0] = 0;
	}
	else clean_up_after_desk_accessory(); /* message[0] !menu related */
	}
	while ( button == 2 ) graf_mkstate(d,d,&button,d);
	menu_bar(menu3_address,FALSE);
	wind_close(wind_id);
	wind_delete(wind_id);
	v_hide_c(handle);
	Setscreen(buffer,buffer,-1);
	graf_mouse(POINT_HAND,0);
	v_show_c(handle,0);
	}



update_screen(buffer,menu)
	long buffer,menu;
	{
	v_hide_c(handle);
	menu_bar(menu,FALSE);
	copy_picture(buffer,SHOWN);
	menu_bar(menu,TRUE);
	v_show_c(handle,1);
	}



call_user_function()
	{
	static char problem[] =
	"[0][Master, there is a problem. |\
I can't run this program.| Is the spelling correct? ][ Sorry ]";
	menu_bar(menu3_address,FALSE);
	response = chose_a_file("*.PRG",-1);
	v_hide_c(handle);
	v_show_c(handle,1);
	if(response==CANCEL)
	{
	update_screen(buffer,menu3_address);
	return;
	}
	wind_close(wind_id);
	wind_delete(wind_id);
	copy_picture(buffer,SHOWN);
	Setscreen(buffer,buffer,-1);
	response = Pexec(0,filename,"",0L);
	Setscreen(SHOWN,SHOWN,-1);
	Setpallete(palette);
	set_window();
	vswr_mode(handle,2);			  /*** Reset Transparent Text ***/
	vsf_color(handle,touch_up_color); /*** Reset Fill color       ***/
	vsl_color(handle,touch_up_color); /*** Reset Finger color     ***/
	vsf_interior(handle,2);           /*** Reset fill to Pattern  ***/
	vsf_style(handle,fill_index);     /*** with current default.  ***/
	update_screen(buffer,menu3_address);
	graf_mouse(ARROW,0);
	v_show_c(handle,0);
	if (response < 0 ) form_alert(1,problem);
	}



check_if_help_was_pressed()
	{
	if ( Cnecin() == HELP ) show_help_message();
	}



show_help_message()
	{
	static char help1[] =
"[0][ |Press the Right  |mouse button to  |toggle the touchup  |\
menu. ][ Ok | More ]";
	static char help2[] =
"[0][ |Press both Buttons  |or select DONE via |the menu \
to exit. ][ Ok | More ]";
	static char help3[] =
"[0][ |The User Function |is an interface |for your own custom  |\
designed routines.][ Ok | More ]";
	static char help4[] =
"[0][ |The screen is not  |protected at THIS |level. Thus your  |\
program can modify it.  ][ Ok ]";
	graf_mouse(ARROW,0);
	response=form_alert(2,help1);
	if (response == MORE) response = form_alert(2,help2);
	if (response == MORE) response = form_alert(2,help3);
	if (response == MORE) form_alert(1,help4);
	graf_mouse(POINT_HAND,0);
	}




setup_fill()
	{
	static char fill_text[] =
"[0][ |  Oh Nuts! ( New Carpet )   | | <Choose your mistake.>  | ]\
[ << | Ok | >> ]";
	menu_bar(menu3_address,FALSE);
	I = 3;
	for(;;)
		{
		copy_picture(buffer,SHOWN);
		vsf_style(handle,fill_index);
		shadow_text(100,150,"This is the color",touch_up_color);
		v_rfbox(handle,box);
		response = form_alert(I,fill_text);
		switch(response)
			{
			case 1:
				fill_index--;
				if (fill_index < 1)
				{
				RING_BELL();
				fill_index = 1;
				I=3;
				}
				break;
			case 3:
				fill_index++;
				if (fill_index > 24)
				{
				RING_BELL();
				fill_index = 24;
				I=1;
				}
				break;
			case 2:
				return;
			}
		}
	menu_bar(menu3_address,TRUE);
	}



set_check(item1,item2,item3)
	int item1,item2,item3;
	{
	menu_icheck(menu3_address,item1,TRUE);
	menu_icheck(menu3_address,item2,FALSE);
	menu_icheck(menu3_address,item3,FALSE);
	}




define_field()
	{
	static char define_text[] =
"[0][ |Store which piece?: |Drag the LEFT mouse |button. To EXIT: |\
Press the RIGHT button.  ][ OK ]";
	v_show_c(handle,0);
	form_alert(1,define_text);
	graf_mouse(THIN_CROSS,0);
	while()
	{
	graf_mkstate(&p[0],&p[1],&button,&key);
	switch(button)
	{
	case 1:	    /* Cut Sprite/Mask From Background */
		graf_rubberbox(p[0],p[1],0,0,&p[2],&p[3]);
		set_sprite_parameters();
		cut_sprite(buffer,buffer);
		break;
	case 2:	    /* Ok, the sprite and/or mask has been defined. */
		set_restrictions(TRUE);/* Allow various Paste,etc. operations */
		if(buffer!=MASK) set_mask_restrictions(FALSE);
		else set_mask_restrictions(TRUE);
		if(buffer==MASK) mask_exists = TRUE;
		graf_mouse(ARROW,0);
		return;
	}
	}
	}


set_window()
	{
	int wx,wy,ww,wh;
	wind_get(0,WF_WORKXYWH,&wx,&wy,&ww,&wh);
	wind_id = wind_create(0,ww/2,wh/2,8,8);
	wind_open(wind_id,ww/2,wh/2,8,8);
	return;
	}



clean_up_after_desk_accessory()
	{
	int wx,wy,ww,wh,t1,t2,test=OK;
	message[0]=0;
	wind_get(0,WF_WORKXYWH,&wx,&wy,&ww,&wh);
	update_screen(buffer,menu3_address);
	}